SystemOrganization addCategory: #GhostProxiesTests!

Object subclass: #User
	instanceVariableNames: 'username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests'!

!User classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 11:12'!
named: aName
	^ self new username: aName! !

!User methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 11:09'!
username ^ username! !

!User methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 11:08'!
username: anObject
	username := anObject! !

TestCase subclass: #SimpleForwarderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests'!

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/22/2011 16:57'!
testSimpleForwardingForClasses
    | aProxy aUser |
       aUser := User named: 'Kurt'.
       
	[aProxy := ClassProxy createProxyAndReplace: User. 
	Transcript show: aProxy name; cr.
       self assert: User name equals: #User. 
    self assert: aUser username equals: 'Kurt'.
	] ensure: [ aProxy uninstall ]! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/22/2011 16:27'!
testSimpleForwardingForMethod
       | aProxy aUser method |
       aUser := User named: 'Kurt'.
       method := User methodDict at: #username.
       [aProxy := ObjectProxy createProxyAndReplace: method. 
       self assert: aProxy getSource equals: 'username ^ username'. 
       self assert: aUser username equals: 'Kurt'.
	 ] ensure: [ aProxy uninstall ]! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/25/2011 15:55'!
testSimpleForwardingForMethodWithOptimizedInstall
       | aProxy aUser method |
       aUser := User named: 'Kurt'.
       method := User methodDict at: #username.
       [aProxy := ObjectProxy createProxyAndReplaceMethod: method. 
       self assert: aProxy getSource equals: 'username ^ username'. 
       self assert: aUser username equals: 'Kurt'.
	 ] ensure: [ aProxy uninstall ]! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/25/2011 15:54'!
testSimpleForwardingForRegularObject
	| proxy |
	proxy := ObjectProxy proxyFor: (Point x: 3 y: 4). 
	self assert: proxy x equals: 3. 
	self assert: proxy y equals: 4.! !
